package jp.hishidama.eval.exp;

import jp.hishidama.eval.*;
import jp.hishidama.eval.srch.SearchAdapter;
import junit.framework.TestCase;

/**
 * ォ牉ZqւeXg.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class ChangeOperatorTest extends TestCase {

	/*
	 * ZqւeXgE\bh
	 */
	public void testPower() {

		Rule rule = ExpRuleFactory.getDefaultRule();
		Expression src = rule.parse("5*4**3**2*-1");
		assertEquals("5 * 4 ** 3 ** 2 * -1", src.toString());
		assertEquals(-5 * 64 * 64, src.evalLong());

		Expression bas = src.dup();
		assertEquals("5 * 4 ** 3 ** 2 * -1", bas.toString());
		bas.search(new SearchAdapter() {
			// ݏ扉Zq́u**vu^vɕς
			public void search(AbstractExpression exp) {
				if (exp instanceof PowerExpression) {
					exp.setOperator("^");
				}
			}
		});
		assertEquals("5 * 4 ^ 3 ^ 2 * -1", bas.toString());

		// Ô͕̂ςȂ
		assertEquals("5 * 4 ** 3 ** 2 * -1", src.toString());
	}

	public void testComma() {

		Rule rule = ExpRuleFactory.getDefaultRule();
		Expression src = rule.parse("a=1,b=test(1,2),c=a+b");
		assertEquals("a = 1, b = test(1, 2), c = a + b", src.toString());

		Expression bas = src.dup();
		assertEquals("a = 1, b = test(1, 2), c = a + b", bas.toString());
		bas.search(new SearchAdapter() {
			// J}Zq́u,vu;vɕς
			public void search(AbstractExpression exp) {
				if (exp instanceof CommaExpression) {
					exp.setOperator(";");
				}
			}
		});
		assertEquals("a = 1; b = test(1, 2); c = a + b", bas.toString());

		// Ô͕̂ςȂ
		assertEquals("a = 1, b = test(1, 2), c = a + b", src.toString());
	}

}
