package jp.hishidama.eval.exp;

import java.util.*;

import jp.hishidama.eval.*;
import jp.hishidama.eval.func.*;
import jp.hishidama.eval.var.*;
import junit.framework.TestCase;

/**
 * Zqւ[̃eXg.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class PowerTest extends TestCase {

	/*
	 * ZqւeXgE\bh
	 */
	public void testPower() {
		Map map = new HashMap();

		BasicPowerRuleFactory factory = new BasicPowerRuleFactory();
		Rule rule;

		rule = factory.getRule();
		testEval(rule, "-2^3^2", null, null, -64);
		map.put("a", new Long(5));
		testEval(rule, "a^=2", map, null, 25);

		rule = ExpRuleFactory.getDefaultRule();
		testEval(rule, "-2**3**2", null, null, -64);
		testEval(rule, "-2^3^2", null, null, -2 ^ 3 ^ 2); // -1Fʂ͔rI_a

		rule = factory.getRule(); // č쐬FftHg[ƉeĂȂƂ̊mF
		testEval(rule, "-2^3^2", null, null, -64);
		testParse(rule, "-2**3**2");
	}

	/**
	 * ñeXg.
	 * 
	 * @param str
	 *            
	 * @param map
	 *            ϐ}bv
	 * @param func
	 *            ֐`
	 * @param expected
	 *            
	 * @version 2007.02.09
	 */
	private void testEval(Rule rule, String str, Map map, Function func,
			long expected) {
		System.out.println("" + str + "");
		Expression exp = rule.parse(str);
		if (map != null) {
			MapVariable var = new MapVariable();
			var.setMap(map);
			exp.setVariable(var);
		}
		// exp.dump(0);
		System.out.println(exp.toString());
		if (func != null) {
			exp.setFunction(func);
		}
		long ret = exp.evalLong();
		System.out.println("= " + ret);
		assertEquals(expected, ret);
	}

	/**
	 * ُñeXg.
	 * <p>
	 * ́E\͂EvalExceptionN͂B<br>
	 * ibZ[WǂɂẴ`FbN͏ȗj
	 * </p>
	 * 
	 * @param str
	 *            
	 */
	private void testParse(Rule rule, String str) {
		System.out.println("" + str + "");
		Expression exp;
		try {
			exp = rule.parse(str);
		} catch (EvalException e) {
			System.out.println(e.toString());
			return;
		}
		// exp.dump(0);
		System.out.println(exp.toString());
		fail();
	}

	/**
	 * ƎZqɍւt@Ng[̗.
	 * <p>
	 * ݏ̉ZqBASIĆu^vɂĂ݂B
	 * </p>
	 */
	class BasicPowerRuleFactory extends ExpRuleFactory {

		public BasicPowerRuleFactory() {
			super();
		}

		protected AbstractExpression createXorExpression() {
			// u^vrI_ał͎gȂ悤ɂ
			return null;
		}

		protected AbstractExpression createLetXorExpression() {
			// u^=vrI_ał͎gȂ悤ɂ
			return null;
		}

		protected AbstractExpression createPowerExpression() {
			// u^vwZqƂ
			AbstractExpression e = new PowerExpression();
			e.setOperator("^");
			return e;
		}

		protected AbstractExpression createLetPowerExpression() {
			// u^=vwZ̑ZqƂ
			AbstractExpression e = new LetPowerExpression();
			e.setOperator("^=");
			return e;
		}
	}
}
