package jp.hishidama.eval.sample;

import java.util.*;

import jp.hishidama.eval.Expression;
import jp.hishidama.eval.ExpRuleFactory;
import jp.hishidama.eval.var.MapVariable;

/**
 * ϐ̎gp
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class VarSample {

	public static void main(String[] args) {
		example1();
		System.out.println();
		example2();
	}

	private static void example1() {
		Map varMap = new HashMap();
		varMap.put("aaa", new Long(2));
		dumpMap(varMap);
		String str = "1 + aaa * 3";
		System.out.println("@F" + str);
		Expression exp = ExpRuleFactory.getDefaultRule().parse(str);

		exp.setVariable(new MapVariable(varMap));
		System.out.println("ʁF" + exp.evalLong());
	}

	private static void example2() {
		Map varMap = new HashMap();
		varMap.put("aaa", new Long(3));
		dumpMap(varMap);
		String str = "bbb=4, aaa+=bbb*5, aaa+bbb";
		System.out.println("@F" + str);
		Expression exp = ExpRuleFactory.getDefaultRule().parse(str);

		exp.setVariable(new MapVariable(varMap));
		System.out.println("ʁF" + exp.evalLong());
		dumpMap(varMap);
	}

	private static void dumpMap(Map map) {
		for (Iterator i = map.keySet().iterator(); i.hasNext();) {
			String key = (String) i.next();
			Long val = (Long) map.get(key);
			System.out.println(key + " = " + val);
		}
	}
}
