package jp.hishidama.eval.srch;

import jp.hishidama.eval.*;
import jp.hishidama.eval.exp.AbstractExpression;
import jp.hishidama.eval.exp.NumberExpression;
import jp.hishidama.eval.srch.SearchAdapter;
import junit.framework.TestCase;

/**
 * ExpressionT[`eXg.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class SearchTest extends TestCase {

	/*
	 * ExpressionT[`eXgE\bh
	 */
	public void testSearch() {

		Rule rule = ExpRuleFactory.getDefaultRule();
		Expression exp;
		NumberCounter nc;

		exp = rule.parse("99");
		exp.search(nc = new NumberCounter());
		assertEquals(1, nc.count);
		assertEquals(99, nc.check);

		// PZq
		exp = rule.parse("((100)++)-- +-2");
		exp.search(nc = new NumberCounter());
		assertEquals(2, nc.count);
		assertEquals(104, nc.check);

		// 񍀉Zq
		exp = rule.parse("6+5*4/3%2");
		exp.search(nc = new NumberCounter());
		assertEquals(5, nc.count);
		assertEquals(6 * 1 + 5 * 2 + 4 * 3 + 3 * 4 + 2 * 5, nc.check);

		// Ȃ
		exp = rule.parse("a-b&c^d");
		exp.search(nc = new NumberCounter());
		assertEquals(0, nc.count);
		assertEquals(0, nc.check);

		// ֐Ez
		exp = rule.parse("test[1].get(2,3)[4+5][6]");
		exp.search(nc = new NumberCounter());
		assertEquals(6, nc.count);
		assertEquals(1 + 2 * 2 + 3 * 3 + 4 * 4 + 5 * 5 + 6 * 6, nc.check);
	}

	class NumberCounter extends SearchAdapter {

		public int count = 0;

		public long check = 0;

		public void search(AbstractExpression exp) {
			if (exp instanceof NumberExpression) {
				// System.out.println("[" + count + "]" + exp);
				count++;
				long val = exp.evalLong();
				check += count * val;
			}
		}

	}

}
